c     ============================================
      subroutine b4step2(maxmx,maxmy,mbc,mx,my,meqn,q,
     &            xlower,ylower,dx,dy,time,dt,maux,aux)
c     ============================================
c
c     # called before each call to step
c     # use to set time-dependent aux arrays or perform other tasks.
c
c     #This particular routine sets negative
c     values of q(i,j,1) to zero, as well as the corresponding q(i,j,m)
c     for m=1,meqn.  This should occur only because of rounding error.

      implicit double precision (a-h,o-z)

      dimension q(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc, meqn)
      dimension aux(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc, maux)


c=====================Parameters===========================================
       common /comrp/ grav
       common /tolerance/ depthtolerance
       common /generation/ iquake
c==========================================================================

c=====================Bathymetry Common Blocks=============================
       include 'bathcommon.i'

c======================================================================
      abs_tol=depthtolerance
      t=time

c     #check for negative states before initiating step
      do i=1-mbc,mx+mbc
      do j=1-mbc,my+mbc
        do m=1,meqn
           if (.not.(q(i,j,m).eq.q(i,j,m))) then
	      write(*,*) 'B4STEP2:SOLUTION ERROR ABORTING CALCULATION'
              write(*,*) 'B4STEP2:i,j,mx,my,q',i,j,mx,my,q(i,j,m)
	      stop
           endif
        enddo

        if (q(i,j,1).lt.abs_tol) then
	   addtob=dmax1(q(i,j,1),0.d0)
           do m=1,meqn
                q(i,j,m)=0.d0
           enddo
	   aux(i,j,1)=aux(i,j,1)+addtob
        endif

      enddo
      enddo


c======EARTHQUAKE===========================================================
       if (iquake.eq.2) then

          call faultquake(maxmx,maxmy,mbc,mx,my,
     &         xlower,ylower,dx,dy,t,dt,maux,aux,
     &	       xlowbath,ylowbath,xhibath,yhibath,dxbath,dybath,
     &	       mxbath,mybath,mbath,mbathsize,i0bath,mbathorder,
     &	       mbathfiles,bathwork,
     &	       xlowfault,ylowfault,xhifault,yhifault,
     &	       dxfault,dyfault,dtfault,t0fault,tffault,
     &	       mxfault,myfault,mtfault,faultwork)
       endif
c===========================================================================



      return
      end
