
c===========================================================================
       subroutine bathinterp(auxij,xim,xcell,xip,yjm,ycell,yjp,
     &                    xxlow,yylow,dxx,dyy,mxx,myy,zz,interp)
c===========================================================================

c     bathinterp reaverages topography resetting the auxij grid cell

      implicit none

      integer mxx,myy

      logical interp

      double precision zz(1:mxx,1:myy)

      double precision auxij,xim,xcell,xip,yjm,ycell,yjp,dx,dy
      double precision dxx,dyy,dxxii,dyyjj,xiim,xiip,yjjm,yjjp
      double precision iistartold,iiendold,jjstartold,jjendold
      double precision ii0old,jj0old
      double precision diistart,diiend,djjstart,djjend,dii0,djj0
      double precision slopex0,slopexf,slopey
      double precision auxy0,auxyf,deltax,deltay
      double precision xxii0,xxiif,yyjj0,yyjjf
      double precision auxc,area,wsum,capacy,capacyy,pi
      double precision xxlow,yylow,yyhi,xxhi,yjjc,xiic

      integer jjstart,jjend,iistart,iiend,jj,ii,mm,ii0,jj0,iif,jjf
      integer jj0z,jjfz

      integer mcapa

      common /latlongrid/ mcapa

       pi=3.14159265359d0

       dx=xip-xim
       dy=yjp-yjm

       xxhi=xxlow+mxx*dxx
       yyhi=yylow+myy*dyy
	
C========WARN IF CALLED INCORRECTLY==========

	if ((xim-xxlow).lt.0.d0.or.(xip-xxhi).gt.0.d0) then
	      xim=dmax1(xxlow,xim)
              xip=dmin1(xxhi,xip)
        endif
              
	if ((yjm-yylow).lt.0.d0.or.(yjp-yyhi).gt.0.d0) then
	   yjm=dmax1(yylow,yjm)
	   yjp=dmin1(yyhi,yjp)
	endif
c=========================================

c============capacity averaging============================================
	if (mcapa.gt.0) then
           capacy=dabs(cos((pi/180.d0)*ycell))
        else
           capacy=1.d0
        endif
c===========================================================================


c======== if grid cell is smaller than bathymetry interpolate===============

      if (dxx.gt.dx.and.dyy.gt.dy.and.interp) then

         dii0=(xcell-(xxlow+0.5d0*dxx))/dxx
	 ii0=idint(dii0)+1
	 ii0=min(mxx,ii0)
	 ii0=max(1,ii0)

	 djj0=(ycell-(yylow+0.5d0*dyy))/dyy
	 jj0=idint(djj0)+1
	 jj0=min(myy,jj0)
	 jj0=max(1,jj0)

         if (ii0.eq.mxx) then
	    ii0=mxx-1
         endif

	 if (jj0.eq.myy) then
	     jj0=myy-1
	 endif

         iif=ii0+1
         jjf=jj0+1

	 yyjj0=yylow + (jj0-.5d0)*dyy
         xxii0=xxlow + (ii0-.5d0)*dxx

	 deltax=xcell-xxii0
	 deltay=ycell-yyjj0

         jjfz=myy-jjf+1
         jj0z=myy-jj0+1

	 slopex0=(zz(iif,jj0z)-zz(ii0,jj0z))/dxx
         slopexf=(zz(iif,jjfz)-zz(ii0,jjfz))/dxx

         auxy0 = zz(ii0,jj0z) + slopex0*deltax
         auxyf = zz(ii0,jjfz) + slopexf*deltax

         slopey= (auxyf-auxy0)/dyy

	 auxij = auxij + auxy0 + slopey*deltay

c=otherwise average the topography cells onto the computational grid cell===

      else

	    djjstart=(yjm-yylow)/dyy
	    jjstart=idint(djjstart)+1
	    jjstart=max(1,jjstart)

	    djjend=(yjp-yylow)/dyy
	    jjend=idint(djjend)+1
	    jjend=min(myy,jjend)

	    diistart=(xim-xxlow)/dxx
	    iistart=idint(diistart)+1
	    iistart=max(1,iistart)

	    diiend=(xip-xxlow)/dxx
	    iiend=idint(diiend)+1
	    iiend=min(mxx,iiend)

      	    area=0.d0
	    wsum=0.d0

            do jj=jjstart,jjend
	       yjjc=yylow + (jj-.5d0)*dyy
	       yjjm=yylow + (jj-1.d0)*dyy
	       yjjp=yylow + (jj)*dyy
               dyyjj=min(yjjp,yjp)-max(yjm,yjjm)
	       dyyjj=max(0.d0,dyyjj)

	       capacyy=dabs(cos((pi/180)*yjjc))

               do ii=iistart,iiend
	    	  xiic=xxlow + (ii-.5d0)*dxx
	    	  xiim=xxlow + (ii-1.d0)*dxx
	    	  xiip=xxlow + (ii)*dxx
                  dxxii=min(xiip,xip)-max(xim,xiim)
		  dxxii=max(0.d0,dxxii)

		  area=area+dxxii*dyyjj
		  wsum=wsum + zz(ii,myy-jj+1)*dxxii*dyyjj*capacyy
               enddo
            enddo
	    auxij = auxij + wsum/(area*capacy)
	endif

       return
       end
