c
c
c =========================================================
      subroutine src1d(meqn,mbc,mx1d,q1d,maux,aux1d,t,dt)
c =========================================================
      implicit double precision (a-h,o-z)

      dimension   q1d(mx1d, meqn)
      dimension aux1d(mx1d, maux)
c
      common /manningcoef/ coeff
c
c     # This routine should be a simplified version of src2 
c     # which applies source terms for a 1-d slice of data along the
c     # edge of a grid.  This is called only from qad where the conservative
c     # fix-up is applied and is used to apply source terms over partial
c     # time steps to the coarse grid cell values used in solving Riemann 
c     # problems at the interface between coarse and fine grids.


      common /tolerance/ depthtolerance
      common /comrp/ grav
c     # incorporates friction

	Chezy=-grav*(coeff**2)
	tol=1.d-5
	do i=1,mx1d


	   h=q1d(i,1)
	   hu=q1d(i,2)
	   hv=q1d(i,3)

	   if (h.lt.depthtolerance) then
	   	q1d(i,2)=0.d0
		q1d(i,3)=0.d0

	   else
	   	u=hu/h
		gamma=dt*Chezy*sign(1.d0,hu)/(h**(7./3.))
		if (hu.gt.0.d0) then
		   q1d(i,2)= (0.5d0/gamma)
     &			+dsqrt((0.25d0/gamma**2)-(hu/gamma))
     		elseif (hu.lt.0.d0) then
		   q1d(i,2)= (0.5d0/gamma)
     &			-dsqrt((0.25d0/gamma**2)-(hu/gamma))
     		endif

		v=hv/h
		gamma=dt*Chezy*sign(1.d0,hv)/(h**(7./3.))
		if (hv.gt.0.d0) then
		   q1d(i,3)= (0.5d0/gamma)
     &			+dsqrt((0.25d0/gamma**2)-(hv/gamma))
     		elseif (hv.lt.0.d0) then
		   q1d(i,3)= (0.5d0/gamma)
     &			-dsqrt((0.25d0/gamma**2)-(hv/gamma))
     		endif

	   endif

	enddo
c
      return
      end
