%waterplot plots the water surface for different grids.
[X,Y]=ndgrid(xedge,yedge);
%====add an extra column and row to b so that surf plots correctly
eta(:,my+1)=eta(:,my);
eta(mx+1,:)=eta(mx,:);
h(:,my+1)=h(:,my);
h(mx+1,:)=h(mx,:);

%==zero transparency if coarse grids are below finer grids ===
erasegrid;
%============================================================

%============================================================
%==zero transparency if eta is actually dry land ===
erasedry;
%============================================================
%watercolormap;
colormap(water);
cw=surf(X,Y,eta.*covered_ind.*dry_ind);
caxis([-.6,.6]);
if (PlotGrid(level)==1)
    set(cw,'FaceColor','flat','EdgeColor',[0 0 0]);
else
    set(cw,'FaceColor','flat','EdgeColor','none');
end

if (PlotGridEdges(level)==1)
    l1=line(xedge,0*xedge+yedge(1),eta(:,1)+1000,'Color','k','LineWidth',1);
    l2=line(xedge,0*xedge+yedge(end),eta(:,end)+1000,'Color','k','LineWidth',1);
    l3=line(0*yedge+xedge(1),yedge,eta(1,:)+1000,'Color','k','LineWidth',1);
    l4=line(0*yedge+xedge(end),yedge,eta(end,:)+1000,'Color','k','LineWidth',1);
    
end

ylabel('Latitude','Fontsize',12)
xlabel('Longitude','Fontsize',12)
